<?php
/**
 * All-in-One WP Migration
 * Copyright (C) 2014-2018 ServMask Inc.
 *
 * Modified Copyright (C) 2025 Lead Connector
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

if ( ! defined( 'ABSPATH' ) ) {
	die( 'Well Sir You Cannot Jump Here...haha' );
}

class Lcm_Import_Check_Encryption {

	public static function execute( $params ) {

		// Read package.json file
		$handle = lcm_open( lcm_package_path( $params ), 'r' );

		// Parse package.json file
		$package = lcm_read( $handle, filesize( lcm_package_path( $params ) ) );
		$package = json_decode( $package, true );

		// Close handle
		lcm_close( $handle );

		// No encryption provided
		if ( empty( $package['Encrypted'] ) || empty( $package['EncryptedSignature'] ) ) {
			return $params;
		}

		// Check decryption support
		if ( ! lcm_can_decrypt() ) {
			if ( defined( 'WP_CLI' ) ) {
				WP_CLI::error( __( 'Importing an encrypted backup is not supported on this server. The process cannot continue.', 'lc-migrator' ) );
			} else {
				Lcm_Status::server_cannot_decrypt( __( 'Importing an encrypted backup is not supported on this server. The process cannot continue.', 'lc-migrator' ) );
				exit;
			}
		}

		// Get WP CLI decryption password
		if ( defined( 'WP_CLI' ) ) {
			$params['decryption_password'] = readline( __( 'Backup is encrypted. Please provide decryption password: ', 'lc-migrator' ) );
		}

		// Validate decryption password
		if ( ! empty( $params['decryption_password'] ) ) {
			if ( lcm_is_decryption_password_valid( $package['EncryptedSignature'], $params['decryption_password'] ) ) {

				// Set progress
				Lcm_Status::info( __( 'Decryption password validated.', 'lc-migrator' ) );

				return $params;
			}

			$decryption_password_error = __( 'The decryption password is not valid. The process cannot continue.', 'lc-migrator' );

			if ( defined( 'WP_CLI' ) ) {
				WP_CLI::error( $decryption_password_error );
			} else {
				Lcm_Status::backup_is_encrypted( $decryption_password_error );
				exit;
			}
		}

		Lcm_Status::backup_is_encrypted( null );
		exit;
	}
}
